<?php

$output_path = 'cache/coord.csv';
$coord_data = NULL;
$output_data = NULL;
$lock_dir = "coord_csv";

$address_data_array = $_POST["address"];
$coord_data_array = $_POST["coord"];

$return_coord_data_array = array();


if(!empty($address_data_array)){
	
	foreach($address_data_array as $key => $address_data){
		
		$address_data = str_replace(array("\r\n","\r","\n", "\t"), '', $address_data);
		$address_data = strip_tags($address_data);
		$coord_data = $coord_data_array[$key];
		
		if(empty($coord_data)){
			
			include_once("map_function.php");
			
			//キャッシュファイルが存在しない場合はそのファイルを作成する。
			if(!is_file($output_path)){
				$split_output_path = explode("/", $output_path);
				if(count($split_output_path) > 1){
					unset($split_output_path [count($split_output_path) - 1]);
					$mkdir = "";
					foreach($split_output_path as $value){
						$mkdir .= $value."/";
						@mkdir($mkdir);
					}
					$handle = fopen($output_path, "w");		//ファイル書き出し処理
					fwrite($handle, $output_data);
					fclose($handle);
				}
			}
			
			//キャッシュと住所のマッチングを行う
			$return_array = match_address($output_path, $address_data);
			$coord_data = $return_array["coord_data"];
			

			if(empty($coord_data)){
			
				lock($lock_dir);	//キャッシュの更新がかぶらないようロックする
				
				//ロックをかけて改めてマッチングを行う
				$return_array = match_address($output_path, $address_data);
				$coord_data = $return_array["coord_data"];
				$output_data = $return_array["output_data"];
				
				if(empty($coord_data)){
						
					//GoogleMapApiから座標を取得する
					$url = "http://maps.google.com/maps/api/geocode/json?address='".urlencode($address_data)."'&sensor=false";
					$res = file_get_contents($url);
					$res_array = json_decode($res, TRUE);
					$lat = $res_array['results']['0']['geometry']['location']['lat'];
					$lng = $res_array['results']['0']['geometry']['location']['lng'];
					
					if($lat != NULL && $lng != NULL){
						
						$coord_data = $lat.",".$lng;	//戻り
						$output_data .= $address_data.",".$lat.",".$lng."\r\n";	//ファイル書き出し用
							
						
						$handle = fopen($output_path, "w");		//ファイル書き出し処理
						fwrite($handle, $output_data);
						fclose($handle);
					}
				}
				
				unlock($lock_dir);	//ロック解除
				
			}

		}
		
		$return_coord_data_array[] = $coord_data;
	}
	
	$return_coord_data = implode("/", $return_coord_data_array);
}



echo $return_coord_data;

?>