<?php

/*
*	キャッシュと住所のマッチングを行う
*/
function match_address($output_path, $address){

	$return_array = array();
	$coord_data = NULL;
	$output_data = NULL;

	$handle = fopen($output_path,"r");
	while($data = fgets($handle)){
		$output_data .= $data;
		$data = rtrim($data);
		$split_data = explode(",",$data);
		if($address == $split_data[0]){
			$coord_data = $split_data[1].",".$split_data[2];
			break;
		}
		
	}
	fclose($handle);
	
	$return_array["coord_data"] = $coord_data;
	$return_array["output_data"] = $output_data;
	
	return $return_array;
}



/*
*	ロック処理
*/
function lock($dir_name) {
		
	$lock_dir = "lock/";
	@mkdir($lock_dir);
		
	while (1) {
		timeover_delete_dir(600, $lock_dir.$dir_name);
		if (@mkdir ($lock_dir.$dir_name, 0777)) {
			break;
		} else {
			usleep(10000);
		}
	}
}


/*
*	ロック解除処理
*/
function unlock($dir_name){
	$lock_dir = "lock/";
	@rmdir ($lock_dir.$dir_name);
}


/*
*	削除されるはずのディレクトリが残っていたときの対処（エラー回避）
*/
function timeover_delete_dir($delete_time, $dir_name){
	if(is_dir($dir_name)){
		$now_time = time();
		$dir_time = date('U', filemtime($dir_name));
		$difference_time =  $now_time - $dir_time;
		if($difference_time > $delete_time){
			@rmdir ($dir_name);
		}
	}
}

?>